unit mainpq;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PriorityQueue;

type
  TMainForm = class(TForm)
    RecursiveCheckBox: TCheckBox;
    SepLabel: TLabel;
    SepEdit: TEdit;
    ListLabel: TLabel;
    ListEdit: TEdit;
    ClearButton: TButton;
    InsertButton: TButton;
    InsertEdit: TEdit;
    procedure RecursiveCheckBoxClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure InsertEditChange(Sender: TObject);
    procedure SepEditChange(Sender: TObject);
  private
    { Private declarations }
    FList: TSortedIntList;
  public
    { Public declarations }
    procedure UpdateViews;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.RecursiveCheckBoxClick(Sender: TObject);
begin
  UpdateViews;
end;

procedure TMainForm.UpdateViews;
begin
  if RecursiveCheckBox.Checked
  then ListEdit.Text := ListToStrR ( FList, SepEdit.Text )
  else ListEdit.Text := ListToStrI ( FList, SepEdit.Text )
end;

procedure TMainForm.ClearButtonClick(Sender: TObject);
begin
  DisposeList ( FList );
  FList := nil;
  UpdateViews;
end;

procedure TMainForm.InsertButtonClick(Sender: TObject);
var
  v: Integer; // value to be inserted
begin
  {@ TryStrToInt(InsertEdit.Text, x) }
  v := StrToInt ( InsertEdit.Text );
  if RecursiveCheckBox.Checked
  then InsertListR ( FList, v )
  else InsertListI ( FList, v );
  UpdateViews;
end;

procedure TMainForm.InsertEditChange(Sender: TObject);
var
  dummy: Integer; // to capture result of TryStrToInt
begin
  InsertButton.Enabled := TryStrToInt ( InsertEdit.Text, dummy );
end;

procedure TMainForm.SepEditChange(Sender: TObject);
begin
  UpdateViews;
end;

end.
